from __future__ import print_function
import sys, json, codecs

from ..singleton.singleton import Singleton
from datetime import datetime

class Logger(object):
    __metaclass__ = Singleton
    logLevel = 1

    def __init__(self):
        self.updateLogLevel()

    def updateLogLevel(self):
        with open('store/configuration.json') as conFile:
            config = json.load(conFile)
        # if there is no loglevel in config, add default value and save it
        if 'logLevel' not in config:
            config['logLevel'] = 1
            with open('store/configuration.json', 'w') as conFile:
                json.dump(config, conFile)
        else:
            self.logLevel = config['logLevel']
        now = str(datetime.now())[:-4]
        finalStr = now + ' INFO ' + 'logger.updateLogLevel' + ' | ' + 'New log level: ' + str(self.logLevel)

        with open('/store/log/flowmon_app.log', 'a') as f:
            print(finalStr, file=f)

    def log(self, level, method, text):
        if level > self.logLevel:
            return
        levelStr = ''
        if level == 1:
            levelStr = ' INFO: '
        elif level == 2:
            levelStr = ' DEBUG: '
        now = str(datetime.now())[:-4]
        finalStr = now + levelStr + method + ' | ' + text

        with codecs.open('/store/log/flowmon_app.log', 'a', encoding="utf-8") as f:
            #print(finalStr, file=f)
            f.write(finalStr+'\n')
