function validateDataDashboard() {
    if (new Date($('#fromInp').val()) > new Date($('#toInp').val())) {
        blinkRed($("label[for='fromInp']"));
        blinkRed($("label[for='toInp']"));
        return false
    }
    if ($("#sourceInp").val().length > 0 && !validateIP($("#sourceInp").val())) {
        blinkRed($("label[for='sourceInp']"));
        return false
    }
    if ($("#targetInp").val().length > 0 && !validateIP($("#targetInp").val())) {
        blinkRed($("label[for='targetInp']"));
        return false
    }
    if ($("#priorityValInp").val().length > 0) {
        if (isNaN(parseInt($("#priorityValInp").val()))) {
            blinkRed($("label[for='priorityTypeInp']"));
            return false
        }
        else if ((parseInt($("#priorityValInp").val()) < 0 || parseInt($("#priorityValInp").val()) > 5)) {
            blinkRed($("label[for='priorityTypeInp']"));
            return false
        }
        else {
            if (($("#priorityTypeInp").val() === "1" && parseInt($("#priorityValInp").val()) === 5) ||
                ($("#priorityTypeInp").val() === "2" && parseInt($("#priorityValInp").val()) === 1) ||
                ($("#priorityTypeInp").val() === "3" && parseInt($("#priorityValInp").val()) === 0)) {
                blinkRed($("label[for='priorityTypeInp']"));
                return false
            }
        }
    }
    return true
}

function parseISOLocal(s) {
    var b = s.split(/\D/);
    //b.push("00");
    console.log(b, '=>', new Date(b[0], b[1] - 1, b[2], b[3], b[4], b[5]));
    return new Date(b[0], b[1] - 1, b[2], b[3], b[4], b[5]);
}

function generateChartGraphLegend(t, methodsCount) {
    console.log('Methods count: ', methodsCount, t.data.datasets);

    var e = [];
    var svg1 = `<svg class="labelText" width="17" height="17"><rect x="1" y="1" rx="1" ry="1" width="15" height="15" style="fill:`;
    var svg2 = `;stroke:black;stroke-width:1;opacity:0.9" /><path class="tick1" d="M2 4 L9 12 L6 14" style="display: block;" /><path class="tick2" d="M15 1 L9 14 L6 13" style="display: block;" /><path class="tick3" d="M6 15 L7 10 l2 4" style="display: block;" /></svg>`;

    e.push('<button class="btn btn-xs" id="chartLegendToggleAll" style="margin-top: 15px; margin-left: 5px">Toggle all</button>');
    e.push('<table class="barLegend ' + t.id + '-legend" style="margin-top: 9px; margin-left: 5px">');
    if (methodsCount > 12) {
        for (var i = 0; i < t.data.datasets.length; i++) {
            t.data.datasets[i]['label'] = sanitize(t.data.datasets[i]['label']);

            if (i % 2 === 0) {

                e.push('<tr><td>' + svg1 + t.data.datasets[i].backgroundColor + svg2), t.data.datasets[i].label && e.push('</td><td><span class="labelText" title="' + methodsTooltips[t.data.datasets[i].label] + '">' + sanitize(t.data.datasets[i].label) + '</span>'), e.push("</td>");
                if (i === t.data.datasets.length - 1)
                    e.push('</tr>');
            }
            else
                e.push('<td>' + svg1 + t.data.datasets[i].backgroundColor + svg2), t.data.datasets[i].label && e.push('</td><td><span class="labelText" title="' + methodsTooltips[t.data.datasets[i].label] + '">' + sanitize(t.data.datasets[i].label) + '</span>'), e.push("</td></tr>");

        }

    }
    else {
        for (var i = 0; i < t.data.datasets.length; i++)
            e.push('<tr><td>' + svg1 + t.data.datasets[i].backgroundColor + svg2), t.data.datasets[i].label && e.push('</td><td><span class="labelText" title="' + methodsTooltips[t.data.datasets[i].label] + '">' + sanitize(t.data.datasets[i].label) + '</span>'), e.push("</td></tr>");
    }

    return e.push("</table>"), e.join("")
}

function toggleAllCallback() {
    var shown = 0;
    var counterAll = 0;
    for (let tr of Array.from($(".barLegend")[0].children[0].children)) {
        counterAll++;
        if (tr.children[0].children[0].children[1].style.display !== 'none')
            shown++;
    }
    if (shown < counterAll / 2) {
        //show all
        /*for (let tr of $(".barLegend")[0].children[0].children) {
            tr.children[0].children[0].children[1].style.display = 'block';
            tr.children[0].children[0].children[2].style.display = 'block';
            tr.children[0].children[0].children[3].style.display = 'block';
        }*/
        $(".barLegend svg path").show();
        for (let ds of barChart1.data.datasets) {
            ds.hidden = false;
        }
        barChart1.update();
    }
    else {
        //hide all
        /*for (let tr of $(".barLegend")[0].children[0].children) {
            tr.children[0].children[0].children[1].style.display = 'none';
            tr.children[0].children[0].children[2].style.display = 'none';
            tr.children[0].children[0].children[3].style.display = 'none';
        }*/
        $(".barLegend svg path").hide();
        for (let ds of barChart1.data.datasets) {
            ds.hidden = true;
        }
        barChart1.update();
    }
}

$("#openSearchPanel").on('click', _ => {
    $('#searchParamsDiv').collapse('toggle');
});

$('#fromInp').val(_ => {
    let d = new Date();
    d.setDate(d.getDate() - 1);
    let y = d.getFullYear();
    let mon = d.getMonth() + 1;
    if (mon < 10) mon = '0' + mon;
    let day = d.getDate();
    if (day < 10) day = '0' + day;
    let h = d.getHours();
    if (h < 10) h = '0' + h;
    let m = d.getMinutes();
    if (m < 10) m = '0' + m;
    let res = `${y}-${mon}-${day} ${h}:${m}`;
    return res;
}).datetimepicker({
    format: 'Y-m-d H:i'
});

$('#toInp').datetimepicker({
    value: new Date(),
    format: 'Y-m-d H:i'
});


$("#filterInp").multiselect({
    includeSelectAllOption: true,
    selectAllValue: 'select-all-value',
    nonSelectedText: 'Not selected'
});
$("#nfSourceInp").multiselect({
    includeSelectAllOption: true,
    selectAllValue: 'select-all-value',
    nonSelectedText: 'Not selected'
});
$("#priorityDiv").children().hide();


$("#fromInfoVal").html($('#fromInp').val());
$("#toInfoVal").html($('#toInp').val());
$("#graphTypeInfoVal").html($('#graphType option:selected').text());

$("#applyBtn").on('click', _ => {
    // validation
    if (!validateDataDashboard())
        return false;

    $("#searchParamsDiv").collapse('hide');
    $("#barGraphErrorAlert").removeClass('alert-danger').removeClass('alert-warning').html('').hide();
    $("#graph1").hide();
    $("#barGraphLegend").hide();
    $("#loadGifDashB").show();
    $(".advInfoDiv").hide();
    let url = `api/graph/type?type=${$("#graphType").val()}&from=${$('#fromInp').val()}&to=${$('#toInp').val()}`;

    $("#fromInfoVal").html($('#fromInp').val());
    $("#toInfoVal").html($('#toInp').val());
    $("#graphTypeInfoVal").html($('#graphType option:selected').text());

    if ($("#sourceInp").val().length > 0) {
        url += `&source=${$("#sourceInp").val()}`;
        $("#sourceInfoVal").html($("#sourceInp").val());
        $("#sourceInfoDiv").css('display', 'inline');
    }
    else {
        $("#sourceInfoVal").text('');
    }

    if ($("#targetInp").val().length > 0) {
        url += `&target=${$("#targetInp").val()}`;
        $("#targetInfoVal").html($("#targetInp").val());
        $("#targetInfoDiv").css('display', 'inline');
    }
    else {
        $("#targetInfoVal").text('')
    }

    if ($("#perspectiveInp").val() !== '-1') {
        url += `&perspective=${$("#perspectiveInp").val()}`;
        $("#perspectiveInfoVal").html($("#perspectiveInp option:selected").text());
        $("#perspectiveInfoDiv").css('display', 'inline');

        if ($("#priorityValInp").val() !== "") {
            let result = [];
            //if more than
            if ($("#priorityTypeInp").val() === "1") {
                let val = $("#priorityValInp").val();
                for (let v = 1; v < 6; v++) {
                    if (v > val)
                        result.push(v);
                }
            }
            //if less than
            else if ($("#priorityTypeInp").val() === "2") {
                let val = $("#priorityValInp").val();
                for (let v = 1; v < 6; v++) {
                    if (v < val)
                        result.push(v);
                }
            }
            //if equals
            else if ($("#priorityTypeInp").val() === "3") {
                result.push($("#priorityValInp").val());
            }
            url += `&priority=${result}`;

            $("#priorityInfoVal").html(result.join(', '));
            $("#priorityInfoDiv").css('display', 'inline');
        }
    }

    if ($("#nfSourceInp").val().length > 0) {
        let str = $("#nfSourceInp").val().map(el => {return '"' + el + '"'}).join(',');
        url += `&nfsource=[${str}]`;
        let selectedSources = [];
        for (let selS of $("#nfSourceInp").val()) {
            console.log('-', selS);
            //find this in flowsources
            let found;
            for (let s of flowsources){
                console.log('--', s.id);
                if (selS === s.id.toString()){
                    found = s;
                    break;
                }
            }
            selectedSources.push(found.name);
        }
        $("#nfSourceInfoVal").html(selectedSources.join(','));
        $("#nfSourceInfoDiv").css('display', 'inline');
    }
    else {
        $("#nfSourceInfoDiv").css('display', 'none');
    }

    if ($("#filterInp").val().length > 0) {
        let str = $("#filterInp").val().map(el => {return '"' + el + '"'}).join(',');
        url += `&filter=[${str}]`;
        let tmp = [], selObj = $("#filterInp option:selected");
        $("#filterInp option:selected").each(el => {console.log(selObj[el], selObj[el].innerText);tmp.push(selObj[el].innerText)});
        console.log(tmp);
        $("#filterInfoVal").html(tmp.join(','));
        $("#filterInfoDiv").css('display', 'inline');
    }
    else{
        $("#filterInfoDiv").css('display', 'none');
    }

    $.ajax({url: url, timeout: parseInt(localStorage.getItem('components_timeout'))})
        .done(r => {
            r = JSON.parse(r)['data'];
            let ds = [];
            for (let Type in r[0]['stat']) {
                ds.push({
                    label: sanitize(Type) ,
                    data: r.map(el => {
                        return el.stat[Type]
                    }),
                    backgroundColor: colors[ds.length]
                })
            }

            if (typeof barChart1 !== 'undefined') {
                barChart1.destroy();
            }

            $("#graph1").show();

            console.log("HERE ADJUSTING canvas size")
            console.log("ds.length = ", ds.length)

            if (ds.length > 12) { //need to show legend in two columns
                console.log('before change: ', $("#graphTable td:first").width());
                $("#graphTable td")[0].style.width = window.innerWidth / 1.49 + 'px';
                //$("#graphTable td")[1].style.width = '17.4%';
                console.log('after change: ', $("#graphTable td:first").width());
            }
            else { // one column
                $("#graphTable td")[0].style.width = window.innerWidth / 1.39 + 'px';
                //$("#graphTable td")[1].style.width = '8.7%';
            }

            console.log('graphTable td:first width ', $("#graphTable td:first").width(), ' px');
            console.log('Setting canv attr width to ', parseInt($("#graphTable td:first").width()) * 0.9);
            $('#graph1').attr('width', parseInt($("#graphTable td:first").width()) * 0.99).css('width', parseInt($("#graphTable td:first").width()) * 0.99);


            // $("#graph1").attr('width', '1300');
            // $("#graph1").css('width', '1300px');
            $("#loadGifDashB").hide();

            let ifTimeDeltaBigger30Min = (new Date($('#toInp').val()) - new Date($('#fromInp').val()) >= 30 * 60 * 1000);
            console.log('ifTimeDeltaBigger30Min', ifTimeDeltaBigger30Min);


            barChart1 = new Chart($("#graph1"), {
                type: 'bar',
                data: {
                    labels: r.map(el => {
                        return el.from
                    }),
                    datasets: ds
                },
                options: {
                    responsive: true,
                    legend: {
                        display: false,
                    },
                    scales: {
                        xAxes: [{
                            stacked: true,
                            ticks: {
                                fontColor: "#c3c3c3",
                                callback: label => {
                                    if (ifTimeDeltaBigger30Min)
                                        return label.slice(5, -3);
                                    else
                                        return label.slice(5);
                                }
                            },
                        }],
                        yAxes: [{
                            stacked: true,
                            ticks: {
                                fontColor: "#c3c3c3",
                                beginAtZero: true,
                                callback: function (value) {
                                    if (value % 1 === 0) {
                                        return value;
                                    }
                                }
                            },
                        }]
                    },
                    legendCallback: function (t) {
                        return generateChartGraphLegend(t, ds.length);
                    },
                    hover: {
                        onHover: function (e, el) {
                            $("#graph1").css("cursor", el[0] ? "pointer" : "default");
                        }
                    }
                }

            });
            $("#barGraphLegend").html(barChart1.generateLegend());
            $("#barGraphLegend").show();
            $(".labelText").off().on('click', e => {
                let type = "", svg = "";

                if (e.currentTarget.nodeName === "svg") {
                    //type = e.currentTarget.parentElement.parentElement.children[1].children[0].innerText;
                    type = e.target.parentElement.parentElement.nextSibling.children[0].innerText;
                    svg = e.currentTarget;
                }
                else {
                    type = e.target.innerText;
                    //svg = e.target.parentElement.parentElement.children[0].children[0];
                    svg = e.target.parentElement.previousSibling.children[0];
                }

                if (svg.children[1].style.display !== 'none') {
                    //clear tick
                    svg.children[1].style.display = 'none';
                    svg.children[2].style.display = 'none';
                    svg.children[3].style.display = 'none';
                    for (let ds of barChart1.data.datasets) {
                        if (ds.label !== type)
                            continue;
                        ds.hidden = true;
                        break;
                    }
                }
                else {
                    //draw or
                    svg.children[1].style.display = 'block';
                    svg.children[2].style.display = 'block';
                    svg.children[3].style.display = 'block';
                    for (let ds of barChart1.data.datasets) {
                        if (ds.label !== type)
                            continue;
                        ds.hidden = false;
                        break;
                    }
                }
                barChart1.update();

            });
            $("#chartLegendToggleAll").off().on('click', function(){toggleAllCallback()});
            if (localStorage.getItem('typesForDashboard') !== undefined && localStorage.getItem('typesForDashboard') !== '') {
                let types = JSON.parse(localStorage.getItem('typesForDashboard'));
                localStorage.setItem('typesForDashboard', '');
                $("#chartLegendToggleAll").click();
                for (let type  of Array.from(types)) {
                    for (let el of Array.from($("#barGraphLegend td span"))){
                        if (el.innerText === type) {
                            el.click()
                        }
                    }
                }
            }
            else {
                console.log("Check if graph is visible: ", $(".barLegend td path")[0].style.display === 'none');
                // if ($(".barLegend td path")[0].style.display === 'none')
                //     $("#chartLegendToggleAll").click();

                let i = 0;
                for (let el of Array.from($("#barGraphLegend td"))){
                    if (i % 2 !== 0) {
                        i++;
                        continue;
                    }
                    console.log("El ",  el.childNodes[0].childNodes[1], " style:",  el.childNodes[0].childNodes[1].style.display,  " click on ",  el.childNodes[0].childNodes[0]);
                    if (el.childNodes[0].childNodes[1].style.display === "none") {
                        //el.nextSibling.childNodes[0].click()
                    }
                    i++;
                }
            }

            $("#graph1").off().on('click', e => {
                let activeElement = barChart1.getElementAtEvent(e);
                //console.log(barChart1.getElementAtEvent(e));
                //console.log(barChart1.getElementsAtXAxis(e));

                if (activeElement.length === 0)
                    return;

                $(".sourceIpInfoAdditional").hide();
                $("#searchParamsDiv").collapse('hide');
                $("#pieGraphLoad").show();
                $("#pieGraphDiv").hide();
                $("#pieGraphErrorAlert").removeClass('alert-danger').html('');


                //let type = activeElement[0]['_model']['datasetLabel'];

                let fr1 = barChart1.data.labels[0];
                let fr2 = barChart1.data.labels[1];
                let delta = Date.parse(fr2) - Date.parse(fr1);
                let currFr;
                if (activeElement.length !== 0)
                    currFr = activeElement[0]['_model']['label'];
                else
                    currFr = barChart1.getElementsAtXAxis(e)[0]['_model']['label'];
                currFr = parseISOLocal(currFr);

                currFr.setMinutes(currFr.getMinutes());

                let from = currFr.getFullYear() + '-' +
                    ((parseInt(currFr.getMonth()) + 1 < 10) ? '0' + (parseInt(currFr.getMonth()) + 1) : parseInt(currFr.getMonth()) + 1) + '-' +
                    ((currFr.getDate() < 10) ? '0' + currFr.getDate() : currFr.getDate()) + ' ' +
                    ((currFr.getHours() < 10) ? '0' + currFr.getHours() : currFr.getHours()) + ':' +
                    ((currFr.getMinutes() < 10) ? '0' + currFr.getMinutes() : currFr.getMinutes()) + ':' +
                    ((currFr.getSeconds() < 10) ? '0' + currFr.getSeconds() : currFr.getSeconds());

                let currTo = new Date(currFr);
                currTo.setSeconds(currTo.getSeconds() + delta / 1000);

                let to = currTo.getFullYear() + '-' +
                    ((parseInt(currTo.getMonth()) + 1 < 10) ? '0' + (parseInt(currTo.getMonth()) + 1) : parseInt(currTo.getMonth()) + 1) + '-' +
                    ((currTo.getDate() < 10) ? '0' + currTo.getDate() : currTo.getDate()) + ' ' +
                    ((currTo.getHours() < 10) ? '0' + currTo.getHours() : currTo.getHours()) + ':' +
                    ((currTo.getMinutes() < 10) ? '0' + currTo.getMinutes() : currTo.getMinutes()) + ':' +
                    ((currTo.getSeconds() < 10) ? '0' + currTo.getSeconds() : currTo.getSeconds());


                let method = "";
                if (activeElement.length !== 0)
                    method = activeElement[0]['_model']['datasetLabel'];

                // $('#graph1').after(from + '<br>' + to + '<br>' + method + '<br>');

                $("#sourceIpInfoFrom").html(from);
                $("#sourceIpInfoTo").html(to);
                $("#sourceIpInfoType").html(method);
                /*if ($("#sourceInfoVal").text().length !== 0){
                    $("#sourceIpInfoSource").show();
                    $("#sourceIpInfoSourceVal").show().text($("#sourceInfoVal").text());
                }
                if ($("#targetInfoVal").text().length !== 0){
                    $("#sourceIpInfoTarget").show();
                    $("#sourceIpInfoTargetVal").show().text($("#targetInfoVal").text());
                }*/

                let url = `api/graph/top_sources?from=${from}&to=${to}`;
                if (activeElement.length !== 0)
                    url += `&method=${method}`;
                /*if ($("#sourceInp").val().length > 0) {
                    url += `&source=${$("#sourceInp").val()}`;
                }

                if ($("#targetInp").val().length > 0) {
                    url += `&target=${$("#targetInp").val()}`;
                }*/


                $.ajax({
                    url: url,
                    timeout: parseInt(localStorage.getItem('components_timeout'))
                })
                    .done(r => {
                        r = JSON.parse(r);
                        r = r['data'];
                        r.sort((a, b) => {
                            if (a.count < b.count) return 1;
                            if (a.count > b.count) return -1;
                            return 0;
                        });
                        console.log('sorted r:', r.map(el => {
                            return el.count
                        }));

                        eventsTemp = [];
                        for (let s of r)
                            eventsTemp.push(s);


                        /*let colors = [
                            'rgba(255,99,132,1)',
                            'rgba(85,187,132,1)',
                            'rgba(85,91,205,1)',
                            'rgba(130,187,87,1)',
                            'rgba(56,121,200,1)',
                            '#555',
                        ];*/

                        let tmpData = r.slice(0, 5).map(el => {
                            return el.count
                        });

                        let tmpLabels = r.slice(0, 5).map(el => {
                            return el.ip
                        });

                        if (r.length > 5) {
                            tmpData.push(r.slice(5).map(el => {
                                return el.count
                            }).reduce((prevVal, curVal, ind, arr) => {
                                return prevVal + curVal
                            }));
                            tmpLabels.push('Others');
                        }

                        //console.log('tmpData:', tmpData);

                        let data = {
                            datasets: [{
                                data: tmpData,
                                backgroundColor: colorsPie,
                                borderColor: colorsPie
                            }],
                            labels: tmpLabels,

                        };

                        //console.log('data: ', data);

                        if (pieGraph1 !== 0)
                            pieGraph1.destroy();


                        pieGraph1 = new Chart($("#graph2"), {
                            type: 'doughnut',
                            data: data,
                            options: {
                                responsive: false,
                                legend: {
                                    display: false,
                                    position: 'left',
                                    labels: {
                                        fontColor: '#c3c3c3'
                                    }
                                },
                                legendCallback: (chart) => {
                                    let text = `<table class='col-md-4 table'><tbody><tr><td></td><td><b>Source</b></td><td><b>Count</b></td></tr>`;

                                    let iter = 0;
                                    for (let source of r) {
                                        let sourceHtml = '', colorHtml = "";

                                        if (iter < 5)
                                            colorHtml += `<span style="background-color:${chart.data.datasets[0].backgroundColor[iter]}">&nbsp&nbsp</span>`;
                                        else
                                            colorHtml += `<span style="background-color:${colorsPie[5]}">&nbsp&nbsp</span>`;

                                        if (source.country !== "LAN") {
                                            sourceHtml += `<span class="flag flag-${source.country.toLowerCase()}" title="${source.country}"></span>&nbsp;`;
                                        }

                                        if (source.resolved === "") {
                                            sourceHtml += `<span title="${source.ip}" class="topSourceIP">${sanitize(source.ip)}</span>`;
                                        }
                                        else {
                                            sourceHtml += `<span title="${source.ip}" class="topSourceIP">${sanitize(source.resolved)}</span>`
                                        }

                                        if (iter < 5)
                                            text += `<tr><td>${colorHtml}</td><td>${sourceHtml}</td><td>${source.count}</td></tr>`;
                                        else
                                            text += `<tr class="hiddenTr" style="display:none"><td>${colorHtml}</td><td>${sourceHtml}</td><td>${source.count}</td></tr>`;
                                        iter++;
                                    }
                                    text += '</tbody></table>';
                                    console.log('ITER', iter);
                                    if (iter > 5)
                                        text += `<a id="showAllPieLegend" style="color:#dee5ed; cursor: pointer">Show all</a>`;
                                    return text;
                                },
                                title: {
                                    display: true,
                                    fontColor: '#c3c3c3',
                                    text: 'Top 5 source IPs'
                                }
                            }
                        });
                        $("#topSourceIpTable").html(pieGraph1.generateLegend());
                        $("#showAllPieLegend").off().on('click', _ => {
                            let state = $(".hiddenTr")[0].style.display;
                            if (state === 'none') {
                                $(".hiddenTr").show();
                                $("#showAllPieLegend").text('Hide');
                            }
                            else {
                                $(".hiddenTr").hide();
                                $("#showAllPieLegend").text('Show all');
                            }
                        });
                        $.contextMenu({
                            selector: '.topSourceIP',
                            callback: function (key, options, a, origEvent) {
                                console.log(key, options, a, origEvent);
                                if (options === 'applyToGraph') {
                                    //$("#fromInp").val($("#sourceIpInfoFrom").text().slice(0,-3));
                                    //$("#toInp").val($("#sourceIpInfoTo").text().slice(0,-3));
                                    let ip = a['$trigger'][0]['title'];
                                    $("#sourceInp").val(ip);
                                    $("#applyBtn").click();
                                }
                                else if (options === 'applyToEvents') {
                                    $("#clearFiltersBtnEvents").click();
                                    switchToEvents({
                                        from: $("#sourceIpInfoFrom").html(),
                                        to: $("#sourceIpInfoTo").html(),
                                        source: a['$trigger'][0]['title'],
                                        methods: [$("#sourceIpInfoType").html()]
                                    });
                                }
                            },
                            items: {
                                "applyToGraph": {name: "Apply this Source IP as filter to the graph", icon: ""},
                                "applyToEvents": {name: "Apply this Source IP as filter to the Events table", icon: ""},
                            }
                        });
                        $(".topSourceIP").on('click', function (e) {
                            console.log(e);
                            let top = e.originalEvent.pageY;
                            let left = e.originalEvent.pageX;
                            $(this).contextMenu();
                            //let top = parseInt($(".context-menu-rootMenuData")[4].style.top);
                            $(".context-menu-rootMenuData").css('top', top + "px");
                            $(".context-menu-rootMenuData").css('left', left + "px");
                        });


                        eventsTemp = [];

                        $("#pieGraphLoad").hide();
                        $("#pieGraphDiv").show();
                        $("#sourceIpInfoDiv").show();




                    })
                    .fail((a, b, c) => {
                        if (b === 'timeout') {
                            $("#pieGraphLoad").hide();
                            $("#pieGraphErrorAlert").addClass('alert-danger').html(`Request timeout<br>Try increase timeout value in configuration or adjust your search parameters`);
                        }
                        else {
                            $("#pieGraphLoad").hide();
                            $("#pieGraphErrorAlert").addClass('alert-danger').html(sanitize(c));
                        }

                    });


            });

        })
        .fail((a, b, c) => {
            if (b === 'timeout') {
                $("#loadGifDashB").hide();
                $("#barGraphErrorAlert").addClass('alert-danger').html(`Request timeout<br>Try increase timeout value in configuration or adjust your search parameters`).show();
            }
            else {
                console.log(a, b, c);
                console.log(a.status);
                $("#loadGifDashB").hide();
                if ($("#fromInp").val() === $("#toInp").val()) {
                    $("#barGraphErrorAlert").addClass('alert-warning').html("Selected time interval is too short").show();
                    return;
                }
                if (a.status == 502)
                    $("#barGraphErrorAlert").addClass('alert-warning').html("There are no data for selected criteria").show();
                else
                    $("#barGraphErrorAlert").addClass('alert-danger').html(sanitize(a.responseText)).show();
            }

        });

});

$("#applyFilterBtn").on('click', _ => {
    $("#applyBtn").click();
});

$("#clearFiltersBtn").on('click', _ => {
    $('#fromInp').val(_ => {
        let d = new Date();
        d.setDate(d.getDate() - 1);
        let y = d.getFullYear();
        let mon = d.getMonth() + 1;
        if (mon < 10) mon = '0' + mon;
        let day = d.getDate();
        if (day < 10) day = '0' + day;
        let h = d.getHours();
        if (h < 10) h = '0' + h;
        let m = d.getMinutes();
        if (m < 10) m = '0' + m;
        let res = `${y}-${mon}-${day} ${h}:${m}`;
        console.log(res);
        return res;
    });
    $('#toInp').val(_ => {
        let d = new Date();
        let y = d.getFullYear();
        let mon = d.getMonth() + 1;
        if (mon < 10) mon = '0' + mon;
        let day = d.getDate();
        if (day < 10) day = '0' + day;
        let h = d.getHours();
        if (h < 10) h = '0' + h;
        let m = d.getMinutes();
        if (m < 10) m = '0' + m;
        let res = `${y}-${mon}-${day} ${h}:${m}`;
        console.log(res);
        return res;
    });

    $("#sourceInp").val("");
    $("#targetInp").val("");
    $("#graphType").val("events");
    $("#perspectiveInp").val("-1");
    $("#priorityTypeInp").val("1");
    $("#priorityValInp").val("");
    $("#priorityDiv").children().hide();

    $("#filterInp").multiselect('deselectAll', false).multiselect('updateButtonText');
    $("#nfSourceInp").multiselect('deselectAll', false).multiselect('updateButtonText');
});

$("#applyToEventsBtn").on('click', _ => {
    if (!validateDataDashboard())
        return false;

    $("#searchParamsDiv").collapse('hide');

    $("#clearFiltersBtnEvents").click();
    let opts = {
        from: $("#fromInp").val(),
        to: $("#toInp").val(),
    };
    if ($("#sourceInp").val().length > 0)
        opts['source'] = $("#sourceInp").val();
    if ($("#targetInp").val().length > 0)
        opts['target'] = $("#targetInp").val();
    if ($("#perspectiveInp").val() !== -1) {
        $("#priorityDivEvents > *").show();
        opts['perspective'] = $("#perspectiveInp").val();
    }
    if ($("#priorityValInp").val().length > 0) {
        opts['priorityType'] = $("#priorityTypeInp").val();
        opts['priorityVal'] = $("#priorityValInp").val();
    }
    if ($("#filterInp").val().length > 0){
        opts["filter"] = $("#filterInp").val();
        // for (val of $("#filterInp").val())
        //     $("#filterInp").multiselect('select', val);
    }
    if ($("#nfSourceInp").val().length > 0){
        opts["nfSource"] = $("#nfSourceInp").val();
        // for (val of $("#filterInp").val())
        //     $("#filterInp").multiselect('select', val);
    }
    opts['methods'] = [];
    //
    // opts['methods'] = $("span.labelText").toArray().map(el => {
    //     return el.innerText
    // });

    let tmpcnt = 0;
    for (let tr of Array.from($(".barLegend")[0].children[0].children)) {
        for (let td of tr.children){
            if (tmpcnt % 2 === 0) {
                console.log(td, td.children[0].children);
                if (td.children[0].children[1].style.display === 'block'){
                    opts['methods'].push(td.nextSibling.innerText)
                }

            }
            tmpcnt++;
        }
    }

    switchToEvents(opts);
    $("#searchParamsDiv").collapse('hide');
});

$("#perspectiveInp").on('change', _ => {
    if ($("#perspectiveInp").val() !== "-1")
        $("#priorityDiv").children().show();
    else
        $("#priorityDiv").children().hide();
});

// do on page open - load graph
var url = `api/graph/type?type=${$("#graphType").val()}&from=${$('#fromInp').val()}&to=${$('#toInp').val()}`;
let pieGraph1 = 0;
$("#loadGif").show();

console.log('--- FLOWMON APP: ' + ' making request to get graph data');
$.ajax({url: url, timeout: parseInt(localStorage.getItem('components_timeout'))}).done(r => {
    console.log("DONE");
    r = JSON.parse(r)['data'];
    console.log('--- FLOWMON APP: ' + ' response: ', r);
    let ds = [];
    for (let Type in r[0]['stat']) {
        ds.push({
            label: Type,
            data: r.map(el => {
                return el.stat[Type]
            }),
            backgroundColor: colors[ds.length]
        })
    }
    console.log('--- FLOWMON APP: ' + ' transformed data for graph: ', ds);

    $("#graph1").show();
    $("#barGraphLoad").hide();

    if (ds.length > 12) { //need to show legend in two columns
        console.log('before change: ', $("#graphTable td:first").width());
        $("#graphTable td")[0].style.width = window.innerWidth / 1.49 + 'px';
        //$("#graphTable td")[1].style.width = '17.4%';
        console.log('after change: ', $("#graphTable td:first").width());
    }
    else { // one column
        $("#graphTable td")[0].style.width = window.innerWidth / 1.39 + 'px';
        //$("#graphTable td")[1].style.width = '8.7%';
    }

    //console.log('graphTable td:first width ', $("#graphTable td:first").width(), ' px');
    console.log('graphTable td:first width ', $("#graphTable td:first").width(), ' px');
    console.log('Setting canv attr width to ', parseInt($("#graphTable td:first").width()) * 0.9);
    $('#graph1').attr('width', parseInt($("#graphTable td:first").width()) * 0.99).css('width', parseInt($("#graphTable td:first").width()) * 0.99);

    //debugger;

    console.log('--- FLOWMON APP: ' + ' initializing graph ');
    barChart1 = new Chart($("#graph1"), {
        type: 'bar',
        data: {
            labels: r.map(el => {
                return el.from
            }),
            datasets: ds
        },
        options: {
            responsive: false,
            legend: {
                display: false

            },
            scales: {
                xAxes: [{
                    stacked: true,
                    ticks: {
                        fontColor: "#c3c3c3",
                        callback: label => {
                            return label.slice(5, -3)
                        },

                    },

                }],
                yAxes: [{
                    stacked: true,
                    ticks: {
                        fontColor: "#c3c3c3",
                        beginAtZero: true,
                        callback: function (value) {
                            if (value % 1 === 0) {
                                return value;
                            }
                        }
                    },
                }]
            },
            legendCallback: function (t) {
                return generateChartGraphLegend(t, ds.length)
            },
            hover: {
                onHover: function (e, el) {
                    $("#graph1").css("cursor", el[0] ? "pointer" : "default");
                }
            }
        }

    });
    $("#barGraphLegend").html(barChart1.generateLegend());
    //console.log('--- FLOWMON APP: ' + ' graph is ready. Graph data: ');
    //console.log('--- FLOWMON APP: ' + ' --- datasets: ', barChart1.data.datasets);
    //console.log('--- FLOWMON APP: ' + ' --- labels: ', barChart1.data.labels);
    $(".labelText").off().on('click', e => {
        let type = "", svg = "";

        if (e.currentTarget.nodeName === "svg") {
            //type = e.currentTarget.parentElement.parentElement.children[1].children[0].innerText;
            type = e.target.parentElement.parentElement.nextSibling.children[0].innerText;
            svg = e.currentTarget;
        }
        else {
            type = e.target.innerText;
            //svg = e.target.parentElement.parentElement.children[0].children[0];
            svg = e.target.parentElement.previousSibling.children[0];
        }

        if (svg.children[1].style.display !== 'none') {
            //clear tick
            svg.children[1].style.display = 'none';
            svg.children[2].style.display = 'none';
            svg.children[3].style.display = 'none';
            for (let ds of barChart1.data.datasets) {
                if (ds.label !== type)
                    continue;
                ds.hidden = true;
                break;
            }
        }
        else {
            //draw or
            svg.children[1].style.display = 'block';
            svg.children[2].style.display = 'block';
            svg.children[3].style.display = 'block';
            for (let ds of barChart1.data.datasets) {
                if (ds.label !== type)
                    continue;
                ds.hidden = false;
                break;
            }
        }
        barChart1.update();

    });
    $("#chartLegendToggleAll").off().on('click', toggleAllCallback);

    $("#graph1").on('click', e => {
        let activeElement = barChart1.getElementAtEvent(e);
        //console.log(barChart1.getElementAtEvent(e));
        //console.log(barChart1.getElementsAtXAxis(e));

        if (activeElement.length === 0)
            return;

        $(".sourceIpInfoAdditional").hide();
        $("#searchParamsDiv").collapse('hide');
        $("#pieGraphLoad").show();
        $("#pieGraphDiv").hide();
        $("#pieGraphErrorAlert").removeClass('alert-danger').html('');


        //let type = activeElement[0]['_model']['datasetLabel'];

        let fr1 = barChart1.data.labels[0];
        let fr2 = barChart1.data.labels[1];
        let delta = Date.parse(fr2) - Date.parse(fr1);
        let currFr;
        if (activeElement.length !== 0)
            currFr = activeElement[0]['_model']['label'];
        else
            currFr = barChart1.getElementsAtXAxis(e)[0]['_model']['label'];
        currFr = parseISOLocal(currFr);

        currFr.setMinutes(currFr.getMinutes());

        let from = currFr.getFullYear() + '-' +
            ((parseInt(currFr.getMonth()) + 1 < 10) ? '0' + (parseInt(currFr.getMonth()) + 1) : parseInt(currFr.getMonth()) + 1) + '-' +
            ((currFr.getDate() < 10) ? '0' + currFr.getDate() : currFr.getDate()) + ' ' +
            ((currFr.getHours() < 10) ? '0' + currFr.getHours() : currFr.getHours()) + ':' +
            ((currFr.getMinutes() < 10) ? '0' + currFr.getMinutes() : currFr.getMinutes()) + ':' +
            ((currFr.getSeconds() < 10) ? '0' + currFr.getSeconds() : currFr.getSeconds());

        let currTo = new Date(currFr);
        currTo.setSeconds(currTo.getSeconds() + delta / 1000);

        let to = currTo.getFullYear() + '-' +
            ((parseInt(currTo.getMonth()) + 1 < 10) ? '0' + (parseInt(currTo.getMonth()) + 1) : parseInt(currTo.getMonth()) + 1) + '-' +
            ((currTo.getDate() < 10) ? '0' + currTo.getDate() : currTo.getDate()) + ' ' +
            ((currTo.getHours() < 10) ? '0' + currTo.getHours() : currTo.getHours()) + ':' +
            ((currTo.getMinutes() < 10) ? '0' + currTo.getMinutes() : currTo.getMinutes()) + ':' +
            ((currTo.getSeconds() < 10) ? '0' + currTo.getSeconds() : currTo.getSeconds());


        let method = "";
        if (activeElement.length !== 0)
            method = activeElement[0]['_model']['datasetLabel'];

        // $('#graph1').after(from + '<br>' + to + '<br>' + method + '<br>');

        $("#sourceIpInfoFrom").html(from);
        $("#sourceIpInfoTo").html(to);
        $("#sourceIpInfoType").html(method);
        /*if ($("#sourceInfoVal").text().length !== 0){
            $("#sourceIpInfoSource").show();
            $("#sourceIpInfoSourceVal").show().text($("#sourceInfoVal").text());
        }
        if ($("#targetInfoVal").text().length !== 0){
            $("#sourceIpInfoTarget").show();
            $("#sourceIpInfoTargetVal").show().text($("#targetInfoVal").text());
        }*/

        let url = `api/graph/top_sources?from=${from}&to=${to}`;
        if (activeElement.length !== 0)
            url += `&method=${method}`;
        /*if ($("#sourceInp").val().length > 0) {
            url += `&source=${$("#sourceInp").val()}`;
        }

        if ($("#targetInp").val().length > 0) {
            url += `&target=${$("#targetInp").val()}`;
        }*/


        $.ajax({
            url: url,
            timeout: parseInt(localStorage.getItem('components_timeout'))
        })
            .done(r => {
                r = JSON.parse(r);
                r = r['data'];
                r.sort((a, b) => {
                    if (a.count < b.count) return 1;
                    if (a.count > b.count) return -1;
                    return 0;
                });
                console.log('sorted r:', r.map(el => {
                    return el.count
                }));

                eventsTemp = [];
                for (let s of r)
                    eventsTemp.push(s);


                /*let colors = [
                    'rgba(255,99,132,1)',
                    'rgba(85,187,132,1)',
                    'rgba(85,91,205,1)',
                    'rgba(130,187,87,1)',
                    'rgba(56,121,200,1)',
                    '#555',
                ];*/

                let tmpData = r.slice(0, 5).map(el => {
                    return el.count
                });

                let tmpLabels = r.slice(0, 5).map(el => {
                    return el.ip
                });

                if (r.length > 5) {
                    tmpData.push(r.slice(5).map(el => {
                        return el.count
                    }).reduce((prevVal, curVal, ind, arr) => {
                        return prevVal + curVal
                    }));
                    tmpLabels.push('Others');
                }

                //console.log('tmpData:', tmpData);

                let data = {
                    datasets: [{
                        data: tmpData,
                        backgroundColor: colorsPie,
                        borderColor: colorsPie
                    }],
                    labels: tmpLabels,

                };

                //console.log('data: ', data);

                if (pieGraph1 !== 0)
                    pieGraph1.destroy();


                pieGraph1 = new Chart($("#graph2"), {
                    type: 'doughnut',
                    data: data,
                    options: {
                        responsive: false,
                        legend: {
                            display: false,
                            position: 'left',
                            labels: {
                                fontColor: '#c3c3c3'
                            }
                        },
                        legendCallback: (chart) => {
                            let text = `<table class='col-md-4 table'><tbody><tr><td></td><td><b>Source</b></td><td><b>Count</b></td></tr>`;

                            let iter = 0;
                            for (let source of r) {
                                let sourceHtml = '', colorHtml = "";

                                if (iter < 5)
                                    colorHtml += `<span style="background-color:${chart.data.datasets[0].backgroundColor[iter]}">&nbsp&nbsp</span>`;
                                else
                                    colorHtml += `<span style="background-color:${colorsPie[5]}">&nbsp&nbsp</span>`;

                                if (!codesNotShowFlag.includes(source.country)) {
                                    sourceHtml += `<span class="flag flag-${source.country.toLowerCase()}" title="${source.country}"></span>&nbsp;`;
                                }

                                if (source.resolved === "") {
                                    sourceHtml += `<span title="${source.ip}" class="topSourceIP">${sanitize(source.ip)}</span>`;
                                }
                                else {
                                    sourceHtml += `<span title="${source.ip}" class="topSourceIP">${sanitize(source.resolved)}</span>`
                                }

                                if (iter < 5)
                                    text += `<tr><td>${colorHtml}</td><td>${sourceHtml}</td><td>${source.count}</td></tr>`;
                                else
                                    text += `<tr class="hiddenTr" style="display:none"><td>${colorHtml}</td><td>${sourceHtml}</td><td>${source.count}</td></tr>`;
                                iter++;
                            }
                            text += '</tbody></table>';
                            console.log('ITER', iter);
                            if (iter > 5)
                                text += `<a id="showAllPieLegend" style="color:#dee5ed; cursor: pointer">Show all</a>`;
                            return text;
                        },
                        title: {
                            display: true,
                            fontColor: '#c3c3c3',
                            text: 'Top 5 source IPs'
                        }
                    }
                });
                $("#topSourceIpTable").html(pieGraph1.generateLegend());
                $("#showAllPieLegend").off().on('click', _ => {
                    let state = $(".hiddenTr")[0].style.display;
                    if (state === 'none') {
                        $(".hiddenTr").show();
                        $("#showAllPieLegend").text('Hide');
                    }
                    else {
                        $(".hiddenTr").hide();
                        $("#showAllPieLegend").text('Show all');
                    }
                });
                $.contextMenu({
                    selector: '.topSourceIP',
                    callback: function (key, options, a, origEvent) {
                        console.log(key, options, a, origEvent);
                        if (options === 'applyToGraph') {
                            //$("#fromInp").val($("#sourceIpInfoFrom").text().slice(0,-3));
                            //$("#toInp").val($("#sourceIpInfoTo").text().slice(0,-3));
                            let ip = a['$trigger'][0]['title'];
                            $("#sourceInp").val(ip);
                            $("#applyBtn").click();
                        }
                        else if (options === 'applyToEvents') {
                            $("#clearFiltersBtnEvents").click();
                            switchToEvents({
                                from: $("#sourceIpInfoFrom").html(),
                                to: $("#sourceIpInfoTo").html(),
                                source: a['$trigger'][0]['title'],
                                methods: [$("#sourceIpInfoType").html()]
                            });
                        }
                    },
                    items: {
                        "applyToGraph": {name: "Apply this Source IP as filter to the graph", icon: ""},
                        "applyToEvents": {name: "Apply this Source IP as filter to the Events table", icon: ""},
                    }
                });
                $(".topSourceIP").on('click', function (e) {
                    console.log(e);
                    let top = e.originalEvent.pageY;
                    let left = e.originalEvent.pageX;
                    $(this).contextMenu();
                    //let top = parseInt($(".context-menu-rootMenuData")[4].style.top);
                    $(".context-menu-rootMenuData").css('top', top + "px");
                    $(".context-menu-rootMenuData").css('left', left + "px");
                });


                eventsTemp = [];

                $("#pieGraphLoad").hide();
                $("#pieGraphDiv").show();
                $("#sourceIpInfoDiv").show();




            })
            .fail((a, b, c) => {
                if (b === 'timeout') {
                    $("#pieGraphLoad").hide();
                    $("#pieGraphErrorAlert").addClass('alert-danger').html(`Request timeout<br>Try increase timeout value in configuration or adjust your search parameters`);
                }
                else {
                    $("#pieGraphLoad").hide();
                    $("#pieGraphErrorAlert").addClass('alert-danger').html(sanitize(c));
                }

            });


    });
}).fail((a, b, c) => {
    console.log("FAILED");
    console.log(a, b, c);
    if (b === 'timeout') {
        $("#loadGifDashB").hide();
        $("#barGraphLoad").hide();
        $("#barGraphErrorAlert").addClass('alert-danger').html(`Request timeout<br>Try increase timeout value in configuration or adjust your search parameters`).show();
    }
    else {
        console.log(a, b, c);
        $("#loadGifDashB").hide();
        $("#barGraphLoad").hide();
        $("#barGraphErrorAlert").addClass('alert-danger').html(sanitize(a.responseText)).show();
    }
});


$("#delSource").on('click', e => {
    e.preventDefault();
    $("#sourceInp").val('');
    $("#applyBtn").click();
});
$("#delTarget").on('click', e => {
    e.preventDefault();
    $("#targetInp").val('');
    $("#applyBtn").click();
});
$("#delFilter").on('click', _ => {
    //$("#filterInpEvents").val(-1);
    $("#filterInp").multiselect('deselectAll', false).multiselect('updateButtonText');
    $("#applyBtn").click();
});
$("#delNfSource").on('click', _ => {
    $("#nfSourceInp").multiselect('deselectAll', false).multiselect('updateButtonText');
    $("#applyBtn").click();
});
$("#delPerspective").on('click', _ => {
    $("#perspectiveInp").val(-1);
    $("#applyBtn").click();
});
$("#delPriority").on('click', _ => {
    $("#priorityValInp").val("");
    $("#priorityTypeInp").val(1);
    $("#priorityDiv").children().hide();
    $("#applyBtn").click();
});

