function validateDataEvents() {
    if ( new Date($('#fromInpEvents').val()) > new Date($('#toInpEvents').val()) ){
        blinkRed($("label[for='fromInpEvents']"));
        blinkRed($("label[for='toInpEvents']"));
        return false;
    }

    if ($("#sourceInpEvents").val().length > 0 && !validateIP($("#sourceInpEvents").val())){
        blinkRed($("label[for='sourceInpEvents']"));
        return false;
    }

    if ($("#targetInpEvents").val().length > 0 && !validateIP($("#targetInpEvents").val())){
        blinkRed($("label[for='targetInpEvents']"));
        return false;
    }
    if ($("#priorityValInpEvents").val().length > 0) {
        if (isNaN(parseInt($("#priorityValInpEvents").val())) ) {
            blinkRed($("label[for='priorityTypeInpEvents']"));
            return false
        }
        else if ((parseInt($("#priorityValInpEvents").val()) < 0 || parseInt($("#priorityValInpEvents").val()) > 5)){
            blinkRed($("label[for='priorityTypeInpEvents']"));
            return false
        }
        else {
            if (($("#priorityTypeInpEvents").val() === "1" && parseInt($("#priorityValInpEvents").val()) === 5) ||
                ($("#priorityTypeInpEvents").val() === "2" && parseInt($("#priorityValInpEvents").val()) === 1) ||
                ($("#priorityTypeInpEvents").val() === "3" && parseInt($("#priorityValInpEvents").val()) === 0) ){
                    blinkRed($("label[for='priorityTypeInpEvents']"));
                    return false
            }
        }
    }
    return true
}

$('#fromInpEvents').val(_ => {
    let d = new Date();
    d.setDate(d.getDate() - 1);
    let y = d.getFullYear();
    let mon = d.getMonth() + 1;
    if (mon < 10) mon = '0' + mon;
    let day = d.getDate();
    if (day < 10) day = '0' + day;
    let h = d.getHours();
    if (h < 10) h = '0' + h;
    let m = d.getMinutes();
    if (m < 10) m = '0' + m;
    let res = `${y}-${mon}-${day} ${h}:${m}`;
    return res;
}).datetimepicker({
    format: 'Y-m-d H:i'
});

$('#toInpEvents').datetimepicker({
    value: new Date(),
    format: 'Y-m-d H:i'
});


$("#typeInpEvents").multiselect({
    includeSelectAllOption: true,
    selectAllValue: 'select-all-value',
    nonSelectedText: 'Not selected'
});
$("#filterInpEvents").multiselect({
    includeSelectAllOption: true,
    selectAllValue: 'select-all-value',
    nonSelectedText: 'Not selected'
});

$("#priorityDivEvents").children().hide();

$("#nfSourceInpEvents").multiselect({
    includeSelectAllOption: true,
    selectAllValue: 'select-all-value',
    nonSelectedText: 'Not selected'
});

$("#openSearchPanelEvents").on('click', _=> {
    $("#typeInpEvents").multiselect('updateButtonText');
    $("#filterInpEvents").multiselect('updateButtonText');
    $('#searchParamsDivEvents').collapse('toggle')
});

$("#fromInfoValEvents").html($('#fromInpEvents').val());
$("#toInfoValEvents").html($('#toInpEvents').val());

function showEventInfo(data){
    console.log("DATA: ", data);
    $("#eventDetailsTable").html("");
    $("#eventEvidenceTable").html("");
    $("#eventInfoModal img").show();
    $("#eventInfoModal").modal('toggle');
    $("#eventIDHeader").html(sanitize(data.id));
    //$("#eventDetailsInFlowmonA").prop('href', `http://${localStorage.getItem('flowmon_web_host')}/adsplug/events/?_adsLink=tab*Tab.Events.SimpleList|eventDetail[0]*${data.id}`);

    /*$.contextMenu( 'destroy' );
    $.contextMenu({
        selector: '#openInFlowmonBtn',
        callback: function (key, options, ev) {
            let url = localStorage.getItem('flowmon_web_host'), evId = $("#eventIDHeader").val();
            if (options === 'info'){
                url += `/ads/events/?_adsLink=tab*Tab.Events.SimpleList|eventDetail[0]*` + evId;
            }
            else if (options === 'vizualization'){
                url +=`/adsplug/event-visualization/?eventId=` + evId;
            }
            $("#eventInfoModal").append(`<a href="${url}" id="extLinkFlowmon" target="_blank" style="display: none"></a>`);
            $("#extLinkFlowmon").click();

        },
        items: {
            "info": {name: `<a target="_blank" href='${localStorage.getItem('flowmon_web_host')}/ads/events/?_adsLink=tab*Tab.Events.SimpleList|eventDetail[0]*${$("#eventIDHeader").text()}'>Event info</a>`, icon: "", isHtmlName: true},
            "vizualization": {name: `<a target="_blank" href='${localStorage.getItem('flowmon_web_host')}/adsplug/event-visualization/?eventId=${$("#eventIDHeader").text()}'>Event vizualization</a>`, isHtmlName: true}
        }
});*/
    $("#openFlowmonA").attr('href', `${localStorage.getItem('flowmon_web_host')}/ads/events/?_adsLink=tab*Tab.Events.SimpleList|eventDetail[0]*${$("#eventIDHeader").text()}`);
    $("#openFlowmonVisualA").attr('href', `${localStorage.getItem('flowmon_web_host')}/adsplug/event-visualization/?eventId=${$("#eventIDHeader").text()}`);

    $.ajax({
        url: 'api/events/' + data.id,
        timeout: parseInt(localStorage.getItem('components_timeout'))
    }).done(r =>
    {
        r = JSON.parse(r);
        //console.log("Resp1: ", r);
        $("#eventDetailsDiv img").hide();
        $("#eventDetailsTable").html("");

        let sourceHtml = "";
        if (r.source.country !== "LAN") {
            sourceHtml += `<span class="flag flag-${sanitize(r.source.country.toLowerCase())}" title="${sanitize(r.source.country)}"></span>&nbsp;`;
        }
        if (r.source.resolved === "") {
            sourceHtml += `<span>${sanitize(r.source.ip)}</span><br>`;
        }
        else {
            sourceHtml += `<span title="${sanitize(r.source.ip)}">${sanitize(r.source.resolved)}</span><br>`
        }


        let targetsHtml = "";
        if (r.targets.length < 5) {
            for (let target of r.targets) {
                let tstr = "";
                //if (target.country !== "LAN" && target.country !== "MUL") {
                if (!codesNotShowFlag.includes(target.country)) {
                    tstr += `<span class="flag flag-${sanitize(target.country.toLowerCase())}" title="${sanitize(target.country)}"></span>&nbsp;`;
                }
                if (target.resolved === "") {
                    tstr += `<span>${sanitize(target.ip)}</span><br>`;
                }
                else {
                    tstr += `<span title="${sanitize(target.ip)}">${sanitize(target.resolved)}</span>`
                }
                targetsHtml += tstr;
            }
        }
        else {
            for (let i = 0; i < 5; i++) {
                let tstr = "";
                let target = r.targets[i];
                //if (target.country !== "LAN" && target.country !== "MUL") {
                if (!codesNotShowFlag.includes(target.country)) {
                    tstr += `<span class="flag flag-${sanitize(target.country.toLowerCase())}" title="${sanitize(target.country)}"></span>&nbsp;`;
                }
                if (target.resolved === "") {
                    tstr += `<span>${sanitize(target.ip)}</span><br>`;
                }
                else {
                    tstr += `<span title="${sanitize(target.ip)}">${sanitize(target.resolved)}</span><br>`
                }
                targetsHtml += tstr;
            }
            targetsHtml += `<a id="moreTargetsA" data-toggle="moreTargetsCollapse" onclick="$('#moreTargetsCollapse').collapse('toggle');$('#moreTargetsA').hide();">Show all...</a>
                            <div class="collapse" id="moreTargetsCollapse">`;
            for (let i = 5; i < r.targets.length; i++) {
                let tstr = "";
                let target = r.targets[i];
                //if (target.country !== "LAN"  && target.country !== "MUL") {
                if (!codesNotShowFlag.includes(target.country)) {
                    tstr += `<span class="flag flag-${sanitize(target.country.toLowerCase())}" title="${sanitize(target.country)}"></span>&nbsp;`;
                }
                if (target.resolved === "") {
                    tstr += `<span>${sanitize(target.ip)}</span><br>`;
                }
                else {
                    tstr += `<span title="${sanitize(target.ip)}">${sanitize(target.resolved)}</span><br>`
                }
                targetsHtml += tstr;
            }
            targetsHtml += `</div>`;
        }

        /*$("#eventDetailsTable").html(`
            <table class="table">
                <tr>
                    <td><b>Id</b></td>
                    <td><b>Flowstamp</b></td>
                    <td><b>Time</b></td>
                    <td><b>Type</b></td>
                    <td><b>Name</b></td>
                    <td><b>Source</b></td>
                    <td><b>Targets</b></td>
                    <td><b>Certainity</b></td>
                    <td><b>Detail</b></td>
                    <td><b>Perspectives</b></td>
                    <td><b>Comments</b></td>
                    <td><b>False positive</b></td>
                    <td><b>Filters</b></td>
                    <td><b>Flow source</b></td>
                </tr>
                <tr>
                    <td>${r.id}</td>
                    <td>${r.flowStamp}</td>
                    <td>${r.time}</td>
                    <td>${r.type}</td>
                    <td>${r.name}</td>
                    <td>${sourceHtml}</td>
                    <td>${targetsHtml}</td>
                    <td>${r.certainity}</td>
                    <td>${r.detail}</td>
                    <td>${r.perspectives.map(elem => {
                        return `
                            ${perspectives[elem.id]}: <span class="priority-${elem.priority}">${elem.priority}</span>
                        `}).join(',<br>')}</td>
                    <td>${(r['comments'] == null) ? "-" : r['comments']}</td>
                    <td>${r.falsePositive}</td>
                    <td>${r.filters.map(filter => {return filter.name }).join(",<br>")}</td>
                    <td>${r.nfSource.name}</td>
                </tr>
            </table>
        `);*/
        let filtersHTML = [];
        for (let f of r.filters){
            let titleHTML = '';
            console.log("FNAME", f.name, reverse_sanitize(f.name));
            let tmp = filters.filter(el => el.name === f.name)[0]['patterns'];
            let iter = 0;
            for (let pat of tmp) {
                titleHTML += `Pattern: ${sanitize(pat.pattern)}  ${(pat.note == null) ? "" : "Note: "+sanitize(pat.note)} \n`;
                iter++;
            }
            if (iter !== 0)
                filtersHTML.push(`<span title="${sanitize(titleHTML)}">${reverse_sanitize(sanitize(f.name))}</span>`);
            else
                filtersHTML.push(`<span title="No patterns in this filter">${reverse_sanitize(sanitize(f.name))}</span>`);
        }


        let eventInfoTableHtml = `
        <div class="row"><div class="col-md-5 col-md-offset-1"><table class="table">
        <tr><td class="labeltd col-md-3">ID</td><td>${sanitize(r.id)}</td></tr>
        <tr><td class="labeltd">Flowstamp</td><td>${sanitize(r.flowStamp)}</td></tr>
        <tr><td class="labeltd">Time</td><td>${sanitize(r.time)}</td></tr>
        <tr><td class="labeltd">Type</td><td>${sanitize(r.type)}</td></tr>
        <tr><td class="labeltd">Name</td><td>${sanitize(r.name)}</td></tr>
        <tr><td class="labeltd">Source</td><td>${sourceHtml}</td></tr>
        <tr><td class="labeltd">Targets</td><td>${targetsHtml}</td></tr>
        <tr><td class="labeltd">Certainity</td><td>${sanitize(r.certainity)}</td></tr>
        </table></div>
        <div class="col-md-5"><table class="table">
        <tr><td class="labeltd col-md-3">Detail</td><td>${reverse_sanitize(sanitize(r.detail))}</td></tr>
        <tr><td class="labeltd">Perspectives</td><td>${r.perspectives.map(elem => {
            return `${perspectives[elem.id]}: <span class="priority-${sanitize(elem.priority)}">${sanitize(elem.priority)}</span>`
        }).join(',<br>')}</td></tr>
        <tr><td class="labeltd">Comments</td><td>${(r.comments == null) ? '-' : sanitize(r.comments)}</td></tr>
        <tr><td class="labeltd">Falsepositive</td><td>${(r.falsePositive === 0)?"No":"Yes"}</td></tr> 
        <tr><td class="labeltd">Filters</td><td>${filtersHTML.join(",<br>")}</td></tr>
        <tr><td class="labeltd">Flowsource</td><td>${sanitize(r.nfSource.name)}</td></tr>
        </table>
        </div></div>
        `;
        $("#eventDetailsTable").html(eventInfoTableHtml);


    }).fail((r,rr, rrr) => {
        if (rr === 'timeout'){
            $("#evDetInfoImg").hide();
            $("#eventDetailsTable").html(`
                <div class="alert alert-danger col-md-4 col-md-offset-4 text-center">Request timeout<br>Try increase timeout value in configuration or adjust your search parameters</div>
            `);
        }
        else {
            $("#evDetInfoImg").hide();
            $("#eventDetailsTable").html(`
                <div class="alert alert-danger col-md-4 col-md-offset-4 text-center">${rrr}</div>
            `);
        }
    });

    $.ajax({
        url: 'api/events/' + data.id + '/flows',
        timeout: parseInt(localStorage.getItem('components_timeout'))
    }).done(r => {
        r = JSON.parse(r);

        for (let rr of r){
            for (let k in rr)
                rr[k] = sanitize(rr[k])
        }
        //console.log("Resp2: ", r);
        $("#eventEvidenceDiv img").hide();
        $("#eventEvidenceTable").html("");
        let columns = [];
        let str = `
            <table class="table table-striped" style="font-size:90%" id="eventFlowsTable"><thead><tr>`;
        /*for (let outp in r[0]) {
            str += `<td><b>${outputDefinitions[outp]}</b></td>`;
            columns.push({title: outputDefinitions[outp], "data": outp});
        }*/

        let cols = [];
        for (let outp of JSON.parse(localStorage.getItem('flowFormatExternal'))) {
            str += `<td>${outputDefinitions[outp]}</td>`;
            cols.push({name: outp, data: outp});
        }
        console.log(columns);

        str += `</tr></thead>`;
        /*for (let flow of r) {
            str += `<tr>`;
            for (let outp in flow)
                str += `<td>${flow[outp]}</td>`
            str += `</tr>`;
        }*/
        str += `</table>`;

        $("#eventEvidenceTable").html(str);


        $('#eventFlowsTable').DataTable( {
            data: r,
            render: $.fn.dataTable.render.text(),
            columns: cols,
            esponsive: false,
            //processing: true,
            scrollX: true,
            bAutoWidth: false,
            "pagingType": "input",
            language: {
                search: "Search in table: "
            },
        } );


    }).fail((r,rr, rrr) => {
        console.log('error ', r, rr, rrr);
        if (rr === 'timeout'){
            $("#evFlowsInfoImg").hide();
            $("#eventEvidenceTable").html(`
                <div class="alert alert-danger col-md-4 col-md-offset-4 text-center">Request timeout<br>Try increase timeout value in configuration or adjust your search parameters</div>
            `);
        }
        else {
            $("#evFlowsInfoImg").hide();
            if (r.responseText.length > 0)
                $("#eventEvidenceTable").html(`
                    <div class="alert alert-danger col-md-4 col-md-offset-4 text-center">${sanitize(r.responseText.slice(1, -1))}</div>
                `);
            else
                $("#eventEvidenceTable").html(`
                    <div class="alert alert-danger col-md-4 col-md-offset-4 text-center">${sanitize(rrr)}</div>
                `);
        }
    });
}

var dtEv = $('#eventsTable').DataTable({
    ajax: {
        url: `api/events?from=${$('#fromInpEvents').val()}&to=${$('#toInpEvents').val()}`,
        timeout: parseInt(localStorage.getItem('components_timeout')),
        error: function (jqXHR, textStatus, errorThrown) {
            console.log("ERROR AJAX EVENTS ", jqXHR, textStatus, errorThrown);
            if (textStatus !== "abort"){
                $("#tooMuchEventAlert").addClass('alert').addClass('alert-danger').text(`Error occured while getting events. `);
            }
        }
    },
    columns: [
        {
            "data": "perspectives",
            "render": d => {
                //d = sanitize(d);
                let r = "";
                if ($("#perspectiveInpEvents").val() === '-1'){
                    r += d.map(elem => {
                        return `<span class="priority-back-${elem.priority}">&nbsp;&nbsp;&nbsp;&nbsp;</span>
                            ${perspectives[elem.id]}: <span class="priority-${elem.priority}">${elem.priority}</span>`
                    }).join(',<br>');
                }
                else{
                    let tmp = "";
                    for (let t of d){
                        if (t.id == $("#perspectiveInpEvents").val() )
                            tmp += `<span class="priority-back-${t.priority}">&nbsp;&nbsp;&nbsp;&nbsp;</span>
                                ${perspectives[t.id]}: <span class="priority-${t.priority}">${t.priority}</span>`
                    }
                    r = tmp;
                }

                return r;
            },
            "width": "12%"
        },
        {
            "data": "id",
            "width": "7%",
            "render": d => {
                d = sanitize(d);
                return `<span class="eventId" title="Show event details" onclick="showEventInfo({id:${d}})">${d}</span>`
            }
        },
        {
            "data": "time",
            "width": "7%"
        },
        {
            "data": "type",
            "width": "8%",
            "render": d => {
                d = sanitize(d);
                return `<span class="eventType">${d}</span>`
            }
        },
        {
            "data": "detail",
            "width": "20%"
        },
        {
            "data": "source",
            "render": source => {
                let tstr = "";
                //if (source.country !== "LAN") {
                if (!codesNotShowFlag.includes(source.country)) {
                    tstr += `<span class="flag flag-${source.country.toLowerCase()}" title="${sanitize(source.country)}"></span>&nbsp;`;
                }

                if (source.resolved === "") {
                    tstr += `<span class="sourceAddress" data-ip="${source.ip}">${sanitize(source.ip)}</span><br>`;
                }
                else {
                    tstr += `<span class="sourceAddress" data-ip="${source.ip}" title="${source.ip}">${sanitize(source.resolved)}</span><br>`
                }

                return tstr;
            },
            "width": "10%"
        },
        {
            "data": "targets",
            "render": (d, dd, ddd) => {
                let r = "", iter = 0, collapseHtml=`<div class='collapse' id='moreTargets${ddd['id']}'>`;

                for (let target of d) {
                    let tstr = "";
                    //if (target.country !== "LAN" && target.country !== "MUL") {
                    if (!codesNotShowFlag.includes(target.country)) {
                        tstr += `<span class="flag flag-${target.country.toLowerCase()}" title="${sanitize(target.country)}"></span>&nbsp;`;
                    }

                    if (target.resolved === "") {
                        tstr += `<span class="targetAddress" data-ip="${target.ip}">${sanitize(target.ip)}</span><br>`;
                    }
                    else {
                        tstr += `<span class="targetAddress" data-ip="${target.ip}" title="${target.ip}">${sanitize(target.resolved)}</span><br>`
                    }
                    if (iter > 4)
                        collapseHtml += tstr;
                    else
                        r += tstr;
                    iter++;
                }
                collapseHtml += '</div>';

                if (iter > 5) {
                    r += collapseHtml + `<a data-toggle='collapse' class="collapseControl" data-target='#moreTargets${ddd['id']}' onclick="changeTextForCollapseControl(this)">Show all</a>`;
                    return r;
                }
                else
                    return r;
            },
            "width": "10%"
        },
        {
            "data": "nfSource",
            "render": d => {
                return `<span class="eventSource">${sanitize(d.name)}</span>`;
            },
            "width": "10%"
        }
    ],
    scrollY: '500px',
    scrollCollapse: true,
    responsive: false,
    //processing: true,
    scrollX: true,
    bAutoWidth: false,
    language: {
        search: "Search in table: "
    },
    "pagingType": "input",
    initComplete: (q, qq, qqq) => {
        console.log(q, qq, qqq);
    //drawCallback: _ => {
        console.log('EVENTS COUNT ', dtEv.data().length);
        if (dtEv.data().length === 10000){
            console.log('10000 EVENTS!');
            $("#tooMuchEventAlert").addClass('alert').addClass('alert-danger').html(`Application reached the maximum number of events. 
            Probably there are even more events in the selected time period, but due to API limitations they can not be shown`);
        }
        dtEv.columns.adjust().draw();
        $.contextMenu({
            selector: '#eventsTable tbody > tr',
            callback: function (key, options) {
                console.log(this);
                showEventInfo(dtEv.row(this).data());
            },
            items: {
                "eventInfo": {name: "Event info", icon: ""}
            }
        });
        $.contextMenu({
            selector: '.eventType',
            callback: function (key, options, ev) {
                if (options === 'searchByType'){
                    let type = ev['$trigger'][0]['innerText'];
                    $("#typeInpEvents").val(type);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'eventInfo'){
                    showEventInfo(dtEv.row(this[0].parentNode.parentNode).data());
                }
            },
            items: {
                "searchByType": {name: "Search by this type", icon: ""},
                "sep1": "---------",
                "eventInfo": {name: "Event info", icon: ""}
            }
        });
        $.contextMenu({
            selector: '.sourceAddress',
            callback: function (key, options, ev) {
                console.log(ev['$trigger'][0]);
                if (options === 'searchBySource'){
                    let s = ev['$trigger'][0];
                    $("#sourceInpEvents").val(s.dataset.ip);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'searchByTarget'){
                    let s = ev['$trigger'][0];
                    $("#targetInpEvents").val(s.dataset.ip);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'eventInfo'){
                    showEventInfo(dtEv.row(this[0].parentNode.parentNode).data());
                }
            },
            items: {
                "searchBySource": {name: "Search by this address as source address", icon: ""},
                "searchByTarget": {name: "Search by this address as target address", icon: ""},
                "sep1": "---------",
                "eventInfo": {name: "Event info", icon: ""}
            }
        });
        $.contextMenu({
            selector: '.targetAddress',
            callback: function (key, options, ev) {
                if (options === 'searchByTarget'){
                    let s = ev['$trigger'][0];
                    $("#targetInpEvents").val(s.dataset.ip);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'searchBySource'){
                    let s = ev['$trigger'][0];
                    $("#sourceInpEvents").val(s.dataset.ip);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'eventInfo'){
                    showEventInfo(dtEv.row(this[0].parentNode.parentNode).data());
                }
            },
            items: {
                "searchBySource": {name: "Search by this address as source address", icon: ""},
                "searchByTarget": {name: "Search by this address as target address", icon: ""},
                "sep1": "---------",
                "eventInfo": {name: "Event info", icon: ""}
            }
        });
        $(".eventType, .sourceAddress, .targetAddress").on('click', function(e){
            $(this).contextMenu();
            let top = e.originalEvent.pageY;
            let left = e.originalEvent.pageX;
            $(".context-menu-rootMenuData").css('top', top + "px");
            $(".context-menu-rootMenuData").css('left', left + "px");
        });


    }
});

function changeTextForCollapseControl(elem){
    if (elem.innerText === 'Show all')
        elem.innerText = 'Hide';
    else
        elem.innerText = 'Show all';
}

$('#openInFlowmonBtn').on('click', function(e) {
    e.preventDefault();
    $('#openInFlowmonBtn').contextMenu();
});

$('.dataTable').on('dblclick', 'tbody tr', function () {
    let data = dtEv.row(this).data();
    showEventInfo(data);
});
$('.dataTable').on('processing.dt', function (e, settings, processing) {
    //console.log(e, settings, processing);
    $('.dataTables_scrollBody').css('display', processing ? 'none' : 'block');
    $('#loadGif').css('display', processing ? 'block' : 'none');
    if (processing === false)
        dtEv.columns.adjust().draw()
}).dataTable();
$('.dataTable').on('draw.dt', function (e, settings, processing) {
    console.log("DRAW EVENT FIRED");
    $.contextMenu({
            selector: '#eventsTable tbody > tr',
            callback: function (key, options) {
                console.log(this);
                showEventInfo(dtEv.row(this).data());
            },
            items: {
                "eventInfo": {name: "Event info", icon: ""}
            }
        });
        $.contextMenu({
            selector: '.eventType',
            callback: function (key, options, ev) {
                if (options === 'searchByType'){
                    let type = ev['$trigger'][0]['innerText'];
                    $("#typeInpEvents").val(type);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'eventInfo'){
                    showEventInfo(dtEv.row(this[0].parentNode.parentNode).data());
                }
            },
            items: {
                "searchByType": {name: "Search by this type", icon: ""},
                "sep1": "---------",
                "eventInfo": {name: "Event info", icon: ""}
            }
        });
        $.contextMenu({
            selector: '.sourceAddress',
            callback: function (key, options, ev) {
                console.log(ev['$trigger'][0]);
                if (options === 'searchBySource'){
                    let s = ev['$trigger'][0];
                    $("#sourceInpEvents").val(s.dataset.ip);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'searchByTarget'){
                    let s = ev['$trigger'][0];
                    $("#targetInpEvents").val(s.dataset.ip);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'eventInfo'){
                    showEventInfo(dtEv.row(this[0].parentNode.parentNode).data());
                }
            },
            items: {
                "searchBySource": {name: "Search by this address as source address", icon: ""},
                "searchByTarget": {name: "Search by this address as target address", icon: ""},
                "sep1": "---------",
                "eventInfo": {name: "Event info", icon: ""}
            }
        });
        $.contextMenu({
            selector: '.targetAddress',
            callback: function (key, options, ev) {
                if (options === 'searchByTarget'){
                    let s = ev['$trigger'][0];
                    $("#targetInpEvents").val(s.dataset.ip);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'searchBySource'){
                    let s = ev['$trigger'][0];
                    $("#sourceInpEvents").val(s.dataset.ip);
                    $("#applyBtnEvents").click();
                }
                else if (options === 'eventInfo'){
                    showEventInfo(dtEv.row(this[0].parentNode.parentNode).data());
                }
            },
            items: {
                "searchBySource": {name: "Search by this address as source address", icon: ""},
                "searchByTarget": {name: "Search by this address as target address", icon: ""},
                "sep1": "---------",
                "eventInfo": {name: "Event info", icon: ""}
            }
        });
        $(".eventType, .sourceAddress, .targetAddress").on('click', function(e){
            $(this).contextMenu();
            let top = e.originalEvent.pageY;
            let left = e.originalEvent.pageX;
            $(".context-menu-rootMenuData").css('top', top + "px");
            $(".context-menu-rootMenuData").css('left', left + "px");
        });
}).dataTable();



$("#applyBtnEvents").on('click', _ => {
    if (!validateDataEvents())
        return;

    $("#searchParamsDivEvents").collapse('hide');
    $(".advInfoDivEvents").hide();

    $("#fromInfoValEvents").html($('#fromInpEvents').val());
    $("#toInfoValEvents").html($('#toInpEvents').val());

    let url = `api/events?from=${$('#fromInpEvents').val()}&to=${$('#toInpEvents').val()}`;

    if ($("#sourceInpEvents").val().length > 0) {
        url += `&source=${$("#sourceInpEvents").val()}`;
        $("#sourceInfoValEvents").html($("#sourceInpEvents").val());
        $("#sourceInfoDivEvents").css('display', 'inline');
    }
    if ($("#targetInpEvents").val().length > 0) {
        url += `&target=${$("#targetInpEvents").val()}`;
        $("#targetInfoValEvents").html($("#targetInpEvents").val());
        $("#targetInfoDivEvents").css('display', 'inline');
    }
    if ($("#typeInpEvents").val().length > 0) {
        let str = $("#typeInpEvents").val().map(el => {return '"' + el + '"'}).join(',');
        let selectedTypes = $("#typeInpEvents").val();
        url += `&type=[${str}]`;
        if (selectedTypes.length < 4)
            $("#typeInfoValEvents").html($("#typeInpEvents").val().join(','));
        else {
            let shownTypes = "", allTypes = $("#typeInpEvents").val().join(',');
            shownTypes = selectedTypes.slice(0, 3).join(',');
            $("#typeInfoValEvents").html(shownTypes + `<span title='${allTypes}'> and ${selectedTypes.length - 3} more... </span>`);

        }
        $("#typeInfoDivEvents").css('display', 'inline');
    }
    else {
        $("#typeInfoDivEvents").css('display', 'none');
    }
    if ($("#nfSourceInpEvents").val().length > 0) {
        let str = $("#nfSourceInpEvents").val().map(el => {return '"' + el + '"'}).join(',');
        url += `&nfsource=[${str}]`;
        let selectedSources = [];
        for (let selS of $("#nfSourceInpEvents").val()) {
            console.log('-', selS);
            //find this in flowsources
            let found;
            for (let s of flowsources){
                console.log('--', s.id);
                if (selS === s.id.toString()){
                    found = s;
                    break;
                }
            }
            selectedSources.push(found.name);
        }
        $("#nfSourceInfoValEvents").html(selectedSources.join(','));
        $("#nfSourceInfoDivEvents").css('display', 'inline');
    }
    else {
        $("#nfSourceInfoDivEvents").css('display', 'none');
    }

    if ($("#filterInpEvents").val().length > 0) {
        let str = $("#filterInpEvents").val().map(el => {return '"' + el + '"'}).join(',');
        url += `&filter=[${str}]`;
        let tmp = [], selObj = $("#filterInpEvents option:selected");
        $("#filterInpEvents option:selected").each(el => {console.log(selObj[el], selObj[el].innerText);tmp.push(selObj[el].innerText)});
        console.log(tmp);
        $("#filterInfoValEvents").html(tmp.join(','));
        $("#filterInfoDivEvents").css('display', 'inline');
    }
    else{
        $("#filterInfoDivEvents").css('display', 'none');
    }
    if ($("#perspectiveInpEvents").val() !== '-1') {
        url += `&perspective=${$("#perspectiveInpEvents").val()}`;
        $("#perspectiveInfoValEvents").html($("#perspectiveInpEvents option:selected").text());
        $("#perspectiveInfoDivEvents").css('display', 'inline');

        if ($("#priorityValInpEvents").val() !== "") {
            let result = [];
            //if more than
            if ($("#priorityTypeInpEvents").val() === "1") {
                let val = $("#priorityValInpEvents").val();
                for (let v = 1; v < 6; v++) {
                    if (v > val)
                        result.push(v);
                }
            }
            //if less than
            else if ($("#priorityTypeInpEvents").val() === "2") {
                let val = $("#priorityValInpEvents").val();
                for (let v = 1; v < 6; v++) {
                    if (v < val)
                        result.push(v);
                }
            }
            //if equals
            else if ($("#priorityTypeInpEvents").val() === "3") {
                result.push($("#priorityValInpEvents").val());
            }
            url += `&priority=${result}`;

            $("#priorityInfoValEvents").html(result.join(', '));
            $("#priorityInfoDivEvents").css('display', 'inline');
        }
    }

    $("#tooMuchEventAlert").removeClass('alert').removeClass('alert-danger').html('');
    dtEv.ajax.url(url);
    dtEv.ajax.reload( (q, qq, qqq) => {
        console.log(q, qq, qqq);
        console.log('EVENTS COUNT ', dtEv.data().length);
        if (dtEv.data().length === 10000){
            console.log('10000 EVENTS!');
            $("#tooMuchEventAlert").addClass('alert').addClass('alert-danger').html(`Application reached the maximum number of events. 
            Probably there are even more events in the selected time period, but due to API limitations they can not be shown`);
        };
        $(".eventType, .sourceAddress, .targetAddress").off().on('click', function(e){
            $(this).contextMenu();
            let top = e.originalEvent.pageY;
            let left = e.originalEvent.pageX;
            $(".context-menu-rootMenuData").css('top', top + "px");
            $(".context-menu-rootMenuData").css('left', left + "px");
        });
    });

});

$("#clearFiltersBtnEvents").on('click', _ => {
    (function(){
        let d = new Date();
        d.setDate(d.getDate() - 1);
        let y = d.getFullYear();
        let mon = d.getMonth() + 1;
        if (mon < 10) mon = '0' + mon;
        let day = d.getDate();
        if (day < 10) day = '0' + day;
        let h = d.getHours();
        if (h < 10) h = '0' + h;
        let m = d.getMinutes();
        if (m < 10) m = '0' + m;
        let res = `${y}-${mon}-${day} ${h}:${m}`;
        $('#fromInpEvents').val(res);
    })();
    (function(){
        let d = new Date();
        let y = d.getFullYear();
        let mon = d.getMonth() + 1;
        if (mon < 10) mon = '0' + mon;
        let day = d.getDate();
        if (day < 10) day = '0' + day;
        let h = d.getHours();
        if (h < 10) h = '0' + h;
        let m = d.getMinutes();
        if (m < 10) m = '0' + m;
        let res = `${y}-${mon}-${day} ${h}:${m}`;
        $('#toInpEvents').val(res);
    })();

    /*$('#fromInp').val(_ => {
        let d = new Date();
        d.setDate(d.getDate() - 1);
        let y = d.getFullYear();
        let mon = d.getMonth() + 1;
        if (mon < 10) mon = '0' + mon;
        let day = d.getDate();
        if (day < 10) day = '0' + day;
        let h = d.getHours();
        if (h < 10) h = '0' + h;
        let m = d.getMinutes();
        if (m < 10) m = '0' + m;
        let res = `${y}-${mon}-${day} ${h}:${m}`;
        //console.log(res);
        return res;
    });*/
    /*$('#toInpEvents').val(_ => {
        let d = new Date();
        let y = d.getFullYear();
        let mon = d.getMonth() + 1;
        if (mon < 10) mon = '0' + mon;
        let day = d.getDate();
        if (day < 10) day = '0' + day;
        let h = d.getHours();
        if (h < 10) h = '0' + h;
        let m = d.getMinutes();
        if (m < 10) m = '0' + m;
        let res = `${y}-${mon}-${day} ${h}:${m}`;
        //console.log(res);
        return res;
    });*/

    $("#sourceInpEvents").val("");
    $("#targetInpEvents").val("");

    // $("#typeInpEvents").val("-1");
    // $("#filterInpEvents").val("-1");
    $("#typeInpEvents").multiselect('deselectAll', false).multiselect('updateButtonText');
    $("#filterInpEvents").multiselect('deselectAll', false).multiselect('updateButtonText');
    $("#nfSourceInpEvents").multiselect('deselectAll', false).multiselect('updateButtonText');

    $("#perspectiveInpEvents").val("-1");

    $("#priorityValInpEvents").val("");
    $("#priorityTypeInpEvents").val(1);
    $("#priorityDivEvents").children().hide();
});

$("#perspectiveInpEvents").on('change', _ => {
    if ($("#perspectiveInpEvents").val() !== "-1")
        $("#priorityDivEvents").children().show();
    else
        $("#priorityDivEvents").children().hide();
});

$("#showDashbBtn").on('click', _ => {
    if (!validateDataEvents())
        return;

    $("#searchParamsDivEvents").collapse('hide');
    $("#clearFiltersBtn").click();
    if ($("#fromInpEvents").val().length !== 16)
        $("#fromInp").val($("#fromInpEvents").val().slice(0,-3));
    else
        $("#fromInp").val($("#fromInpEvents").val());
    if ($("#toInpEvents").val().length !== 16)
        $("#toInp").val($("#toInpEvents").val().slice(0,-3));
    else
        $("#toInp").val($("#toInpEvents").val());

    if ($("#sourceInpEvents").val().length > 0 )
        $("#sourceInp").val($("#sourceInpEvents").val());

    if ($("#targetInpEvents").val().length > 0 )
        $("#targetInp").val($("#targetInpEvents").val());

    if ($("#perspectiveInpEvents").val() !== "-1") {
        $("#perspectiveInp").val($("#perspectiveInpEvents").val());

        $("#priorityTypeInp").val($("#priorityTypeInpEvents").val());

        if ($("#priorityValInpEvents").val().length > 0) {
            $("#priorityValInp").val($("#priorityValInpEvents").val());

        }
        else {
            $("#priorityValInp").val('');
            $("#priorityDiv").children().hide();
        }
        $("#priorityDiv").children().show();
   }

    if ($("#filterInpEvents").val().length > 0){
        $("#filterInp").multiselect('deselectAll', false);
        for (val of $("#filterInpEvents").val())
            $("#filterInp").multiselect('select', val);
        $("#filterInp").multiselect('updateButtonText');
    }
    if ($("#nfSourceInpEvents").val().length > 0){
        $("#nfSourceInp").multiselect('deselectAll', false);
        for (val of $("#nfSourceInpEvents").val())
            $("#nfSourceInp").multiselect('select', val);
        $("#nfSourceInp").multiselect('updateButtonText');
    }

   if ($("#typeInpEvents").val().length > 0) {
        localStorage.setItem('typesForDashboard', JSON.stringify($("#typeInpEvents").val()))
   }

   $("#dashboard").click();
   $("#applyBtn").click();
});
$("#showFlowsBtn").on('click', _ => {
    if (!validateDataEvents())
        return;

    $("#searchParamsDivEvents").collapse('hide');
    $("#fromInpFlows").val($("#fromInpEvents").val());
    $("#toInpFlows").val($("#toInpEvents").val());
    let filterStr = "";
    if ($("#sourceInpEvents").val().length > 0)
        filterStr += `src ip ${$("#sourceInpEvents").val()}`;
    if ($("#targetInpEvents").val().length > 0){
        if ($("#sourceInpEvents").val().length > 0)
            filterStr += ` and dst ip ${$("#targetInpEvents").val()}`;
        else
            filterStr += `dst ip ${$("#targetInpEvents").val()}`;
    }
    $("#filterInpFlows").val(filterStr);

    $("#flows").click();
    $("#applyBtnFlows").click();
});

$("#delTypeEvents").on('click', _ => {
    //$("#typeInpEvents").val(-1);
    $("#typeInpEvents").multiselect('deselectAll', false).multiselect('updateButtonText');

    $("#applyBtnEvents").click();
});
$("#delSourceEvents").on('click', _ => {
    $("#sourceInpEvents").val("");
    $("#applyBtnEvents").click();
});
$("#delTargetEvents").on('click', _ => {
    $("#targetInpEvents").val("");
    $("#applyBtnEvents").click();
});
$("#delFilterEvents").on('click', _ => {
    //$("#filterInpEvents").val(-1);
    $("#filterInpEvents").multiselect('deselectAll', false).multiselect('updateButtonText');
    $("#applyBtnEvents").click();
});
$("#delPerspectiveEvents").on('click', _ => {
    $("#perspectiveInpEvents").val(-1);
    $("#priorityValInpEvents").val("");
    $("#priorityTypeInpEvents").val(1);
    $("#priorityDivEvents").hide();
    $("#applyBtnEvents").click();
});
$("#delPriorityEvents").on('click', _ => {
    $("#priorityValInpEvents").val("");
    $("#priorityTypeInpEvents").val(1);
    $("#priorityDivEvents").hide();
    $("#applyBtnEvents").click();
});
$("#delNfSourceEvents").on('click', _ => {
    $("#nfSourceInpEvents").multiselect('deselectAll', false).multiselect('updateButtonText');
    $("#applyBtnEvents").click();
});




