var perspectives = {}, filters = [], methods = {}, outputDefinitions = {}, profiles = [], flowsources = [], barChart1, eventsTemp = [], loadedTabs = 0;

//preventing XSS
function sanitize(string) {
    string = String(string);
  const map = {
      '&': '&amp;',
      '<': '&lt;',
      '>': '&gt;',
      '"': '&quot;',
      "'": '&#x27;',
      "/": '&#x2F;',
      "`": '&grave;'
  };
  const reg = /[&<>"'/`]/ig;
  return string.replace(reg, (match)=>(map[match]));
}

function reverse_sanitize(string) {
  return string.replace(/&amp;/ig, "&").replace(/&#37;/ig, "%")
}

function blinkRed($elem) {
    let origCol = $elem.css('color');
    $elem.css('color', 'red');
    setTimeout(function() {
        $elem.css('color', origCol);

        setTimeout(function() {
            let origCol1 = $elem.css('color');
            $elem.css('color', 'red');
            setTimeout(function() {
                $elem.css('color', origCol);
            }, 290);
        }, 200);
    }, 290);
}

function validateIP(str){
    let regexp = /((^\s*((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))\s*$)|(^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$))/ ;
    return regexp.test(str)
}

function ifDataPreloaded(){
    if (Object.keys(perspectives).length > 0){
        if (filters.length > 0){
            if (Object.keys(methods).length > 0){
                if (Object.keys(outputDefinitions).length > 0){
                    if (profiles.length > 0){

                            $("#loadingBlocker").hide();
                            //insertDataIntoSelects();
                            return true

                    }
                }
            }
        }
    }
    return false
}

function ifTabsPreloaded(){
    return (loadedTabs === 3)
}

function hideBlockerWhenReady() {
    if (ifDataPreloaded() === true) {
        $.get('dashboard').done(function(r)  {
            $("#dashboardContent").html(r); loadedTabs++
        });
        $.get('events').done(function(r) {$("#eventsContent").html(r);
            loadedTabs++;
            if (localStorage.getItem('goToEventsTab') === '1'){
                localStorage.setItem('goToEventsTab', '0');

                let obj = {};
                if (localStorage.getItem('sourceIP')) {
                    obj['source'] = localStorage.getItem('sourceIP');
                    localStorage.removeItem('sourceIP');
                }
                if (localStorage.getItem('targetIP')) {
                    obj['target'] = localStorage.getItem('targetIP');
                    localStorage.removeItem('targetIP');
                }
                if (localStorage.getItem('perspectiveId')) {
                    obj['perspective'] = localStorage.getItem('perspectiveId');
                    localStorage.removeItem('perspectiveId');
                }
                if (localStorage.getItem('priorityVal')) {
                    obj['priorityVal'] = localStorage.getItem('priorityVal');
                    localStorage.removeItem('priorityVal');
                }
                if (localStorage.getItem('priorityType')) {
                    obj['priorityType'] = parseInt(localStorage.getItem('priorityType'));
                    localStorage.removeItem('priorityType');
                }
                if (localStorage.getItem('from')) {
                    obj['from'] = localStorage.getItem('from');
                    localStorage.removeItem('from');
                }
                if (localStorage.getItem('to')) {
                    obj['to'] = localStorage.getItem('to');
                    localStorage.removeItem('to');
                }
                console.log('switchin to events', obj);
                switchToEvents(obj);
                /*
                $("#applyBtnEvents").click();
                $("#events").click();*/
                console.log('debug10');

            }
        });
        $.get('flows').done(function(r)  {$("#flowsContent").html(r); loadedTabs++});


        console.log('Data preloaded');
        console.log('Persps', perspectives);
        console.log('Filters', filters);
        console.log('Methods', methods);
        console.log('Outp defs', outputDefinitions);
        return
    }
    setTimeout(hideBlockerWhenReady, 80);
}

function hideAllContextMenus() {
    try {
        $(".topSourceIP").contextMenu("hide");
        $("#openInFlowmonBtn").contextMenu("hide");
        $("#eventsTable tbody > tr").contextMenu("hide");
        $(".eventType").contextMenu("hide");
        $(".sourceAddress").contextMenu("hide");
        $(".targetAddress").contextMenu("hide");
    }
    catch (er){}
}

function insertDataIntoSelects() {

    console.log('Inserting data into inputs');

    let filtersOpts = '';
    for (let f in filters) {
        filtersOpts += '<option value="'+filters[f]['id']+'">'+filters[f]['name']+'</option>';
    }
    $(".filterInputs").html(filtersOpts);

    // let methodsOpts = ``;
    // for (let m in methods)
    //     methodsOpts += `<option value="${methods[m]}">${methods[m]}</option>`;
    // $(".typeInputs").html(methodsOpts);
    //
    // let perspOpts = `<option value="-1">-</option>`;
    // for (let p in perspectives)
    //     perspOpts += `<option value="${p}">${perspectives[p]}</option>`;
    // $(".perspectiveInputs").html(perspOpts);



}

function switchToEvents(options){
    console.log('APPLY TO SEARCH TAB ', options);
    //$("#clearFiltersBtn").click();
    $("#clearFiltersBtnEvents").click();
    if (options['from']){
        $("#fromInpEvents").val(options['from']);
    }
    if (options['to']){
        $("#toInpEvents").val(options['to']);
    }
    if (options['source']){
        $("#sourceInpEvents").val(options['source']);
    }
    if (options['target']){
        $("#targetInpEvents").val(options['target']);
    }
    if (options['perspective']){
        if (options['perspective'] !== "-1")
        $("#perspectiveInpEvents").val(options['perspective']);
    }
    if (options['priorityVal']){
        $("#priorityTypeInpEvents").val(options['priorityType']);
        $("#priorityValInpEvents").val(options['priorityVal']);
        $("#priorityDivEvents").children().show();
    }
    if (options['filter']){
        $("#filterInpEvents").multiselect('deselectAll', false);
        for (let val of options['filter'])
            $("#filterInpEvents").multiselect('select', val);
        $("#filterInpEvents").multiselect('updateButtonText');
    }
    if (options['nfSource']){
        $("#nfSourceInpEvents").multiselect('deselectAll', false);
        for (let val of options['nfSource'])
            $("#nfSourceInpEvents").multiselect('select', val);
        $("#nfSourceInpEvents").multiselect('updateButtonText');
    }
    if (options['methods']){
        for (let m of options['methods'])
            $("#typeInpEvents").multiselect('select', m);
    }


    $("#events").click();
    $("#applyBtnEvents").click();


}

$(document).ready(function() {
    $('.nav-sidebar a.navlink').click(function() {
        $(".nav-sidebar li[class='active']").removeClass('active');
        $('#status').removeClass().html('');
        $(this).parent().addClass('active');
        var action = $(this).attr('id').toLowerCase().replace(/ /g, '_');
        // $.get(action, function(data, status) {
        //     $('#content').html(data);
        // });
        //console.log(action);

        hideAllContextMenus();

        $(".contentDiv").hide();
        $("#"+action+'Content').show();
        if (action === 'events'){
            if (typeof(dtEv) !== undefined) {
                console.log('adjust');
                dtEv.columns.adjust().draw();
            }
        }
        if (action === 'flows'){
            if (dtFlows !== undefined && typeof(dtFlows) !== undefined) {
                console.log('adjust');
                dtFlows.columns.adjust().draw();
            }
        }

        $(".modal-backdrop").hide();

    });
    if (window.location.hash) {
        var site = window.location.hash;
        //console.log('site ',site);
        var link = $(site);
        //console.log(link);
        if (link.length == 1) {
            link.click();
        } else {
            $('.nav-sidebar a:first').click();
        }
    }
    else {
        $('.nav-sidebar a:first').click();
    }



    let loadingBlockerHtml = `
        <div id="loadingBlocker" style="z-index:70;background-color: rgba(20,20,20,0.8);position:fixed;top:0;left:0;height:${$(window).height()}px;width:${$(window).width()}px">
        <img class="center-block" src="static/res/loadingBlocker.gif" style="width:4%; margin-top:${$(window).height()/2}px">
        <br>
        <div class="text-center">Preloading data...</div>
        </div>
    `;
    $("body").append(loadingBlockerHtml);
    hideBlockerWhenReady();

    $.get('output_definitions').done(function(r)  {
        r = JSON.parse(r);
        for (let k in r){
            r[k] = sanitize(r[k]);
        }
        outputDefinitions = r;
    });
    $.get('api/perspectives').done(function(r)  {
        r = JSON.parse(r);
        for (let p of r) {
            let tmp = p.id.toString();
            perspectives[tmp] = sanitize(p.name);
        }

    });
    $.get('api/filters').done(function(r)  {
        r = JSON.parse(r);
        for (let p of r) {
            let obj = {
                id: p.id.toString(),
                name: reverse_sanitize(sanitize(p.name)),
                patterns: p.patterns
            };
            filters.push(obj);
        }
        // let filtersOpts = `<option value="-1">-</option>`;

    });
    $.get('api/methods').done(function(r)  {
        r = JSON.parse(r);
        let methodsTmp = {};
        let tmpArr = [];
        for (let p of r) {
            //let tmp = p.id.toString();
            //methodsTmp[tmp] = p.code;
            tmpArr.push(sanitize(p.code));
        }
        tmpArr.sort();
        let cnt = 1;
        for (let t of tmpArr) {
            methodsTmp[cnt] = t;
            cnt++;
        }
        methods = methodsTmp;
        // let methodsOpts = `<option value="-1">-</option>`;

    });
    $.get('api/netflowSources').done(function(r)  {
        r = JSON.parse(r);
        for (let nfs of r) {
            let obj = {
                id: nfs.id,
                name: sanitize(nfs.name),
                active: nfs.active
            };
            flowsources.push(obj);
        }
        flowsources.sort(function(a,b) {
            if (a.active > b.active) {
            return -1;
            }
            if (a.active < b.active) {
            return 1;
            }
            return 0;
        })
    });

    $.get('api/profiles').done(function(r)  {
        r = JSON.parse(r)['data'];
        for (let p of r) {
            p.name = sanitize(p.name);
            profiles.push(p);
        }

    });

    $.get('config').done(function(r)  {
        r = JSON.parse(r);
        localStorage.setItem('flowmon_web_host', r.webConsole);
        localStorage.setItem('components_timeout', r.componentTimeout);
        localStorage.setItem('flowFormatInternal', JSON.stringify(r.flowFormatInternal));
        localStorage.setItem('flowFormatExternal', JSON.stringify(r.flowFormatExternal));
    })

});

let colors = [ // for bar chart graph
    '#f44336',
    '#00BCD4',
    '#4CAF50',
    '#FF9800',
    '#9C27B0',
    '#8BC34A',
    '#FFEB3B',
    '#3F51B5',
    '#E91E63',
    '#03A9F4',
    '#009688',
    '#CDDC39',
    '#673AB7',
    '#FFC107',
    '#FF5722',
    '#607D8B',
    '#2196F3',

    '#f44336',
    '#00BCD4',
    '#4CAF50',
    '#FF9800',
    '#9C27B0',
    '#8BC34A',
    '#FFEB3B',
    '#3F51B5',
    '#E91E63',
    '#03A9F4',
    '#009688',
    '#CDDC39',
    '#673AB7',
    '#FFC107',
    '#FF5722',
    '#607D8B',
    '#2196F3',
];

let colorsPie = [
    'rgba(244,67,54, 1)',
    'rgba(0,188,212,1)',
    'rgba(76,175,80,1)',
    'rgba(255,152,0,1)',
    'rgba(156,39,176,1)',
    '#555',
];

let methodsTooltips = {
    'ANOMALY': 'Network anomaly',
  'BITTORRENT': 'BitTorrent Traffic',
  'BLACKLIST': 'Communication with blacklisted hosts',
  'BPATTERNS': 'Flow-based behavior patterns',
  'DIRINET': 'Direct internet communication',
  'DICTATTACK': 'Dictionary attack',
  'DIVCOM': 'Target hosts/ports anomaly',
  'REFLECTDOS': 'Amplificated DoS attack',
  'HIGHTRANSF': 'High volume of transferred data',
  'HTTPDICT': 'Web form dictionary attack',
  'ICGUARD': 'Internet connection utilization anomaly',
  'IPV6TUNNEL': 'IPv6 tunneled traffic',
  'INSTMSG': 'Instant messaging traffic',
  'L3ANOMALY': 'L3 network traffic anomaly or protocol modification',
  'LATENCY': 'Network latency anomaly',
  'MULTICAST': 'Multicast traffic',
  'NATDET': 'Network address translation detection',
  'SCANS': 'Port scanning',
  'SRVNA': 'Service not available',
  'TEAMVIEWER': 'TeamViewer desktop sharing',
  'TELNET': 'Telnet anomaly',
  'TOR': 'Communication with TOR anonymization proxy',
  'UPLOAD': 'Data upload anomaly',
  'VOIP': 'VoIP traffic',
  'VPN': 'VPN tunneled traffic detection',
  'WEBSHARE': 'Web sharing traffic',
  'SIPFLOOD': 'Excessive amount of SIP requests',
  'SIPSCAN': 'Horizontal and vertical SIP scans',
  'SIPPROXY': 'Abnormal SIP proxy',
  'ALIENDEV': 'New or unknown device',
  'BROKENSEN': 'Irregular sensor behavior',
  'COUNTRY': 'Communication with poor reputation country',
  'DHCPANOM': 'Suspicious DHCP communication',
  'DNSANOMALY': 'Suspicious DNS communication',
  'DNSQUERY': 'Increased volume of DNS queries',
  'DOS': 'Denial of service attack',
  'ICMPANOM': 'Suspicious ICMP communication',
  'PEERS': 'Increased number of communication partners',
  'RDPDICT': 'RDP dictionary attack',
  'SMTPANOMALY': 'Spam and other SMTP anomalies',
  'SSHDICT': 'SSH dictionary attack',
  'DNSREVERSE': 'Missing DNS reverse records',
};
let codesNotShowFlag = ['MUL', 'LAN', 'LIL', 'LAN', 'XXX'];