echo "--- Installing rpms"
yum --nogpgcheck --disablerepo=* -y localinstall /src_deps/cron_rpms/*.rpm
echo "--- Installing rpms - DONE"

# set timezone
rm -rf /etc/localtime
ln -s /usr/share/zoneinfo/Europe/Prague /etc/localtime

# set log
touch /store/log/flowmon_app.log
rm -rf /store/log/flowmon_app.log
touch /store/log/flowmon_app.log

# create empty config file if doesnt exist
if [ -e /store/configuration.json ]
then
    echo "--- Existing configuration.json"
else
    cp /src_deps/init/configuration.json /store/configuration.json
fi


if [ -e /store/outputDefinitions.json ]
then
    echo "--- Existing outputDefinitions.json "
else
    cp /src_deps/init/outputDefinitions.json /store/outputDefinitions.json
fi

if [ -e /store/widgets.json ]
then
    echo "--- Existing widgets.json "
else
    cp /src_deps/init/widgets.json /store/widgets.json
fi

pip install /src_deps/pip/*


# set logrotate
touch /etc/logrotate.d/flowmon_log
echo '/store/log/flowmon_app.log {
    rotate 7
    size=30M
    create
    dateext
}' >> /etc/logrotate.d/flowmon_log

service rsyslog start
service crond start
